# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

def install():
    print('installing Octave')

    versionsoftfile = control['version'].split('-',1)[0]
    versionsoft = get_file_properties("octave-%s-w64-installer.exe" % versionsoftfile)['ProductVersion']
    for octave in installed_softwares('Octave-'):
        if Version(octave['version']) < Version(versionsoft):
            run(uninstall_cmd(octave['key']))


    install_exe_if_needed("octave-%s-w64-installer.exe" % versionsoftfile,'/S',key='Octave-%s' % versionsoft,min_version=versionsoft,timeout=1200,killbefore=control['impacted_process'])

    create_programs_menu_shortcut('Octave',target=makepath('c:','Octave','Octave-' + versionsoft,'octave.vbs'),arguments='--force-gui',icon=makepath('c:','Octave','Octave-' + versionsoft,'share','octave',versionsoft,'imagelib','octave-logo.ico'))
    remove_desktop_shortcut('GNU Octave (CLI)')
    remove_desktop_shortcut('GNU Octave (GUI)')


def uninstall():
    remove_programs_menu_shortcut('Octave')

def update_package():
    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    lastversion = wgets("https://www.gnu.org/software/octave/download.html",proxies=proxies).split("-w64-installer.exe")[0].split('-')[-1]
    binaryfile64 = 'octave-%s-w64-installer.exe' % lastversion

    for exe in glob.glob('*-w64-installer.exe'):
        if exe != binaryfile64 :
            remove_file(exe)

    if not isfile(binaryfile64):
        wget('https://ftp.gnu.org/gnu/octave/windows/' + binaryfile64, binaryfile64,proxies=proxies)

    control.version = lastversion + "-0"
    control.save_control_to_wapt()

